<?
////////////////////////////////////////
// PHPMine 1.0
//   A Microsoft Winmine clone
// Author: Alexandre Tedeschi (d)
// Email:  alexandrebr @ gmail . com
//

class Winmine_Clone{
	var $grid = Array();
	var $opened = Array();
	var $status;
	var $gameover;
	var $details;

	// Start a new game
	Function newGame($dx=8, $dy=8, $mines=10, $no_mine=Array(-1, -1)){
		$this->details = Array($dx, $dy, $mines, $no_mine);
		$this->opened = Array();
		$this->status  = '';
		$this->gameover = false;
		$tries = 0;
		
		// Generate grid with mines
		while($mines>0){
			for($y = 0; $y < $dy; $y++)
				for($x = 0; $x < $dx; $x++){
					$has_mine = ($mines>0)?rand(0,10):0;
					if($no_mine[0]==$x and $no_mine[1]==$y)
						$has_mine = 0;
					if(!isset($tabu[$y][$x]) || !$tabu[$y][$x] and $has_mine==10)
					{
						$tabu[$y][$x] = 'o';
						$mines--;
					}elseif(!isset($tabu[$y][$x]) || !$tabu[$y][$x])
						$tabu[$y][$x] = 0;
				}
			$tries++;
			if($tries >= 50)
				break;
		}
		$this->details[2] = $this->details[2]-$mines;

		// Parse the grid, setting the numbers
		$lx = $dx-1;
		$ly = $dy-1;
		for($y = 0; $y < $dy; $y++)
			for($x = 0; $x < $dx; $x++)
				if($tabu[$y][$x]==='o'){
					if($y != 0){
						if($x != 0)
							if($tabu[$y-1][$x-1] !== 'o')$tabu[$y-1][$x-1]++;
						if($tabu[$y-1][$x] !== 'o')    $tabu[$y-1][$x]++;
						if($x != $lx)
							if($tabu[$y-1][$x+1] !== 'o')$tabu[$y-1][$x+1]++;
					}

					if($x != 0)
						if($tabu[$y][$x-1] !== 'o')$tabu[$y][$x-1]++;
					if($x != $lx)
						if($tabu[$y][$x+1] !== 'o')$tabu[$y][$x+1]++;

					if($y != $ly){
						if($x != 0)
							if($tabu[$y+1][$x-1] !== 'o')$tabu[$y+1][$x-1]++;
						if($tabu[$y+1][$x] !== 'o')    $tabu[$y+1][$x]++;
						if($x != $lx)
							if($tabu[$y+1][$x+1] !== 'o')$tabu[$y+1][$x+1]++;
					}
				}
		
		$this->grid = $tabu;
	}
	
	// Returns 'true' if space is already open
	Function Opened($px, $py){
		$ab = $this->opened;
		for($x = 0; $x < sizeof($ab); $x++)
			if($ab[$x] == Array($px, $py))
				return true;
		return false;
	}
	
	// Open the selected space, and return its content.
	Function Open($px, $py)
	{
		$tabu = $this->grid;
		$tx = sizeof($tabu[0])-1;
		$ty = sizeof($tabu)-1;
		if($px < 0 or $py < 0 or $px > $tx or $py > $ty)
			return false;
		if(!sizeof($this->opened) && $this->grid[$py][$px]==='o'){
			$this->newGame($this->details[0], $this->details[1], $this->details[2], Array($px, $py));
			$this->open($px, $py);
			return;
		}
		$this->opened[] = Array($px, $py);
		return $this->grid[$py][$px];
	}
	
	// Returns 'true' if there's a non-clicked space
	Function WhereToPlay(){
		$tab = $this->grid;
		for($y = 0; $y < sizeof($tab); $y++)
			for($x = 0; $x < sizeof($tab[$y]); $x++)
				if(!$this->Opened($x, $y) and $tab[$y][$x] !== 'o')
					return true;
		return false;
	}
	
	// Expand all white spaces, from the origin.... This is very slow, needs to be rewritten.
	Function OpenWhite($px, $py){
		$toopen = Array(($px-1).','.($py-1), $px.','.($py-1), ($px+1).','.($py-1),
										($px-1).','.($py  ),                  ($px+1).','.($py  ),
										($px-1).','.($py+1), $px.','.($py+1), ($px+1).','.($py+1));
		$newopen = Array();
		
		for($x = 0; $x < sizeof($toopen); $x++){
			$coo = explode(",", $toopen[$x]);
			if(!$this->Opened($coo[0], $coo[1]))
				if(($play = $this->Open($coo[0], $coo[1])) === 0)
					$newopen[] = $coo;
		}
		for($x = 0; $x < sizeof($newopen); $x++)
			$this->OpenWhite($newopen[$x][0], $newopen[$x][1]);
	}
}
